<?php
namespace Inti\Wp\Plugin;

/**
 * Class PluginLoader
 *
 * @package Inti\Wp\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class PluginLoader implements PluginInterface
{
    /** @var PluginInterface[] */
    private array $plugins = [];

    /**
     * @param PluginInterface $plugin
     */
    public function addPlugin(PluginInterface $plugin)
    {
        $this->plugins[] = $plugin;
    }

    /**
     * Attaches all the plugins.
     */
    public function attach(): void
    {
        foreach ($this->plugins as $plugin) {
            $plugin->attach();
        }
    }
}
